#include <stdio.h>
int main()
{
 int n, m, r;
 int T;
 int i, j, p;
 int min;
 int max;
 int br=0;
 int maxrazlika;

 scanf("%d", &T);

 for(p=0; p<T; p++)
    {
        scanf("%d",&n);
        scanf("%d",&m);
        int A[n];
        int B[m];
        for(i=0;i<n;i++)
        {
          scanf("%d",&A[i]);
        }
        for(j=0;j<m;j++)
        {

          scanf("%d",&B[j]);
        }
    }

 for(p=0; p<T; p++)
 {
    br=0;
    int A[n];
    min = A[0];
    max = A[0];

        for(i=1; i<n; i++)
        {

         if(A[i] < min)
         {
            min = A[i];
         }
         else if (A[i] > max)
         {
            max = A[i];
         }
        }

        maxrazlika=max-min;


        for(i=0; i<n-1; i++)
        {
         r=0;
         r=A[i+1]-A[i];
         if(r<0)
         {
          r=-r;
         }


        if(maxrazlika<r)
        {
         int x=maxrazlika;
         maxrazlika=r;
         r=x;
        }
         while(r)
         {
             int ostatak=maxrazlika%r;
             maxrazlika=r;
             r=ostatak;
         }
         int NZD=maxrazlika;

         if(NZD!=1)
         {
          br++;
         }
        }

    if(br==n-1)
    {
      printf("1 \n");
    }
    else
    {
      printf("0 \n");
    }


 }
    return 0;
}